 ###############################################################################
#
# Duel
# v1.21 (10/09/2015)   2013-2015 Menz Agitat
#
# IRC: irc.epiknet.org  #boulets / #eggdrop
#
# Mes scripts sont tlchargeables sur http://www.eggdrop.fr
#
 ###############################################################################

#
# Description
#
# Ce script permet  un utilisateur d'en dfier un autre en combat singulier.
#
# Une fois le duel lanc, le narrateur (l'Eggdrop) commence  dcrire l'action
# trpidante qui se droule sous vos yeux bahis.
# Il existe 5 types d'action, diffrencis par un symbole affich en dbut de
# ligne :
# 	>		attaque
#		<		contre-attaque
#		~		esquive
#		~<	esquive + contre-attaque
#		x		attaque rate
#		*		raction neutre
# A chaque round, le hasard dcide qui attaque qui. Lorsqu'une attaque est
# lance, il y a une chance pour qu'elle aboutisse, une chance pour qu'elle
# rate, et une chance pour que la victime se dfende de 3 faons possibles
# (esquive, contre-attaque, ou esquive + contre-attaque).
# Des ractions neutres surviennent parfois en rponse  une attaque qui a
# abouti; elles reprsentent les ractions des participants ou du public  ce
# qui vient de se passer et n'ont aucune influence sur le score.
#
# Chaque attaque a un certain nombre de dfenses et de ractions qui lui sont
# associes spcifiquement afin d'avoir un contexte cohrent entre les actions
# et les ractions, et des soins particuliers ont t apports  la varit,
# l'originalit et l'humour.
# La base de donnes contient :
#		128 attaques toutes plus vicieuses les unes que les autres.
#		66 attaques rates car les emmerdes, a arrive...
#		116 esquives avec pied de nez.
#		93 contre-attaques histoire de mettre les points sur les i.
#		46 combos esquive + contre-attaque pour les plus habiles.
#		256 ractions neutres parce que les spectateurs veulent tout savoir.
#
# Le calcul des points s'effectue comme suit :
# 	- Chaque attaque mene  bien rapporte 1pt  l'attaquant.
#		- Une esquive annule l'attaque prcdente.
#		- Une contre-attaque n'annule pas l'attaque mais rapporte 1pt au dfenseur.
#		- Une esquive + contre-attaque annule l'attaque et rapporte 1pt au dfenseur.
#
#	Voici la syntaxe  utiliser pour dfier quelqu'un en duel :
#		!duel <nick> [nombre de rounds gagnants]
# Et voici ce que devra taper celui qui a t provoqu en duel pour accepter de
# relever le dfi (si l'option target_must_accept est active) :
#		!engage
#
# La commande !duel_stats permet au propritaire de l'Eggdrop de compter et
# d'afficher le nombre d'actions de chaque catgorie dans la base de donnes.
#
# Pour activer ou dsactiver Duel sur un chan, vous devez taper ceci sur le chan
# concern :
#		!duels <on/off>
# ou ceci en partyline de l'Eggdrop :
#		.chanset #NomDuChan <+/->duel
#
# Quelques dtails chiants pour ceux qui veulent juste faire un duel au plus
# vite, et bons  savoir pour les autres :
# - Le script utilise une file d'attente temporise indpendante pour
#		l'affichage des messages afin de ne pas engorger les files d'attente de
#		l'Eggdrop en y envoyant beaucoup de messages d'un coup.
#	- Le script est pourvu d'un systme anti-hl, qui permet de ne pas ennuyer les
#		participants  chaque action.
# - Chaque attaque / attaque rate / dfense / raction ne sera pas rpte
#		tant que toutes les autres n'auront pas t vues, et l'ordre est diffrent
#		 chaque cycle. Notez qu'un rehash ou un restart de l'Eggdrop remet les
#		compteurs  0.
#
# Veuillez maintenant vous reporter  la section configuration du script un peu
# plus bas......
#
 ###############################################################################

#
# Licence
#
#		Cette cration est mise  disposition selon le Contrat
#		Attribution-NonCommercial-ShareAlike 3.0 Unported disponible en ligne
#		http://creativecommons.org/licenses/by-nc-sa/3.0/ ou par courrier postal 
#		Creative Commons, 171 Second Street, Suite 300, San Francisco, California
#		94105, USA.
#		Vous pouvez galement consulter la version franaise ici :
#		http://creativecommons.org/licenses/by-nc-sa/3.0/deed.fr
#
 ###############################################################################

if {[::tcl::info::commands ::duel::uninstall] eq "::duel::uninstall"} { ::duel::uninstall }
# Note pour les programmeurs :
# Dans la version 1.6.19 d'Eggdrop, le numro de version affich par .vbottree et [numversion] est incorrect; il affiche 1061800 ou 1061801, ce qui correspond  la version 1.6.18. On utilise donc une autre technique pour vrifier le numro de version.
if { [regsub -all {\.} [lindex $::version 0] ""] < 1620 } { putloglev o * "\00304\[Duel - Erreur\]\003 La version de votre Eggdrop est\00304 ${::version}\003; Duel ne fonctionnera correctement que sur les Eggdrops version 1.6.20 ou suprieure." ; return }
if { [::tcl::info::tclversion] < 8.5 } { putloglev o * "\00304\[Duel - Erreur\]\003 Duel ncessite que Tcl 8.5 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est\00304 ${::tcl_version}\003." ; return }
package require Tcl 8.5
if { [catch { package require msgcat }] } { putloglev o * "\00304\[Duel - erreur\]\003 Duel ncessite le package msgcat pour fonctionner. Le chargement du script a t annul." ;	return }
namespace eval ::duel {



 ###############################################################################
### Configuration
 ###############################################################################

	# Emplacement et nom du fichier de configuration.
	variable config_file "scripts/duel/Duel.cfg"




 ###############################################################################
### Fin de la configuration
 ###############################################################################



	 #############################################################################
	### Initialisation
	 #############################################################################
  variable scriptname "Duel"
  variable version "1.21.20150910"
	setudef flag duel
	# Lecture de la configuration.
	if { [file exists $::duel::config_file] } {
		eval [list source $::duel::config_file]
	} else {
		putloglev o * "\00304\[$::duel::scriptname - erreur\]\003 Le fichier de configuration n'a pas t trouv  l'emplacement indiqu ( $::duel::config_file ). Le chargement du script est annul."
		namespace delete ::duel
		return
	}
	# Chargement des fichiers de langue.
	::msgcat::mcload [file join $::duel::language_files_directory]
	if { $::duel::delay < 2 } { set ::duel::delay 2 }	
	variable special_queue_running 0
	# Initialisation du gnrateur de nombres pseudo-alatoires.
	variable randgen_mod [expr {wide(256)*wide(256)*wide(256)*wide(256)-5}]
	variable randgen_fac [expr {wide(256)*wide(32)}]
	variable randgen_x1 [expr {wide($randgen_mod*rand())}]
	variable randgen_x2 [expr {wide($randgen_mod*rand())}]
	variable randgen_x3 [expr {wide($randgen_mod*rand())}]
	# Procdure de dsinstallation (le script se dsinstalle totalement avant chaque rehash ou  chaque relecture au moyen de la commande "source" ou autre)
	proc uninstall {args} {
		# Message : "Dsallocation des ressources de %s..."
		putlog [::msgcat::mc m0 $::duel::scriptname]
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [::tcl::string::range [namespace current] 2 end]]*] " \{?(::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		foreach running_utimer [utimers] {
			if { [::tcl::string::match "*[namespace current]::*" [lindex $running_utimer 1]] } { killutimer [lindex $running_utimer 2] }
		}
		if { [::tcl::dict::exists $::msgcat::Msgs [::msgcat::mclocale] ::duel] } {
			::tcl::dict::unset ::msgcat::Msgs [::msgcat::mclocale] ::duel
		}
		namespace delete ::duel
	}
	# Chargement de la base de donnes.
	eval [list source $::duel::db_file]
}

 ###############################################################################
### Initialisation d'un duel
 ###############################################################################
proc ::duel::init_fight {nick host hand chan arg} {
	if { (![channel get $chan duel])
		|| ([::tcl::info::exists ::duel::sessions([md5 $chan])])
		|| (($::duel::antiflood)
		&& ([::duel::antiflood $chan $nick]))
	} then {
		return
	} else {
		set arg [lrange [split $arg] 1 end]
		lassign $arg target num_winning_rounds
		if { ($target eq "")
			|| ([set num_args [llength $arg]] > 2)
			|| (($num_args == 2)
			&& (![::tcl::string::is digit $num_winning_rounds]))
		} then {
			# Message : "\037Syntaxe\037 : \002%s\002 \00314\<\003cible\00314> \[\003nombre de rounds gagnants\00314\] \00307|\003 Provoque quelqu'un en duel. Le nombre de rounds gagnants est par dfaut de %s."
			::duel::display_error_msg $chan [::msgcat::mc m2 $::duel::public_cmd $::duel::default_num_winning_rounds]
		} elseif { ![onchan $target $chan] } then {
			# Message : "Tu vois encore des gens qui n'existent pas %s ?"
			::duel::display_error_msg $chan [::msgcat::mc m3 $nick]
		} elseif { ([::tcl::string::equal -nocase $nick $target]) && !($::duel::can_challenge_oneself) } {
			# Message : "%s > Tape-toi plutt la tte contre un mur..."
			::duel::display_error_msg $chan [::msgcat::mc m4 $nick]
		} elseif { ([::tcl::string::equal -nocase $::nick $target]) && !($::duel::can_challenge_bot) } {
			# Message "%s > Trouve-toi plutt un adversaire  ta taille..."
			::duel::display_error_msg $chan [::msgcat::mc m5 $nick]
		} elseif { $num_winning_rounds == 0 } {
			# Message : "%s > Si tu ne veux aucun round, pourquoi demander un duel ?"
			::duel::display_error_msg $chan [::msgcat::mc m6 $nick]
		} elseif { ($::duel::max_winning_rounds != 0) && ($num_winning_rounds > $::duel::max_winning_rounds) } {
			# Message : "%s > Les duels en plus de %s rounds gagnants sont interdits par les rglages actuels du script."
			::duel::display_error_msg $chan [::msgcat::mc m7 $nick $::duel::max_winning_rounds]
		} elseif { [::duel::db_sanity_check] } {
			# Message : "\00304\[%s - erreur\]\003 La base de donnes comporte des erreurs. Plus de dtails concernant le type d'erreur et les lignes concernes sont affichs en partyline et dans les logs de l'Eggdrop, merci d'en avertir un administrateur."
			::duel::output_message $chan help PRIVMSG [::msgcat::mc m8 $::duel::scriptname]
			return
		} else {
			# On corrige la casse des caractres dans le nom de la cible si ncessaire
			set users_list [chanlist $chan]
			set target [lindex $users_list [lsearch -nocase -exact $users_list $target]]
			# Si l'option target_must_accept est active, on attend l'accord de la cible pour lancer le duel
			if { $::duel::target_must_accept } {
				set session_hash [md5 "$target,$chan"]
				if { ([::tcl::info::exists ::duel::pending_duel_requests])
					&& ([::tcl::info::exists ::duel::pending_duel_requests($session_hash)])
				} then {
					killutimer [::tcl::dict::get $::duel::pending_duel_requests($session_hash) "timerID"]
				}
				set timerID [utimer $::duel::duel_request_timeout [list unset ::duel::pending_duel_requests($session_hash)]]
				::tcl::dict::set ::duel::pending_duel_requests($session_hash) "nick" $nick
				::tcl::dict::set ::duel::pending_duel_requests($session_hash) "target" $target
				::tcl::dict::set ::duel::pending_duel_requests($session_hash) "chan" $chan
				::tcl::dict::set ::duel::pending_duel_requests($session_hash) "num_winning_rounds" $num_winning_rounds
				::tcl::dict::set ::duel::pending_duel_requests($session_hash) "timerID" $timerID
				# Message : "\002%s\002 > Tu viens d'tre provoqu en duel par %s, souhaites-tu relever le dfi ? Pour accepter, tape \002%s\002 avant que la proposition n'expire. Tu as %s secondes."
				::duel::output_message $chan help PRIVMSG [::msgcat::mc m9 $target $nick $::duel::acceptance_cmd $::duel::duel_request_timeout]
			} else {
				::duel::engage_fight $nick $target $chan $num_winning_rounds $users_list
			}
		}
	}
}

 ###############################################################################
### Le dfi accepte le duel
 ###############################################################################
proc ::duel::duel_acceptance {nick host hand chan arg} {
	if { (![::tcl::info::exists ::duel::pending_duel_requests])
		|| (![::tcl::info::exists ::duel::pending_duel_requests([set session_hash [md5 "$nick,$chan"]])])
		|| ([::tcl::info::exists ::duel::sessions([md5 $chan])])
	} then {
		return
	} else {
		foreach {varname content} $::duel::pending_duel_requests($session_hash) {
			set $varname $content
		}
		killutimer [::tcl::dict::get $::duel::pending_duel_requests($session_hash) "timerID"]
		unset ::duel::pending_duel_requests($session_hash)
		::duel::engage_fight $nick $target $chan $num_winning_rounds
	}
}

 ###############################################################################
### Dmarrage des hostilits
 ###############################################################################
proc ::duel::engage_fight {nick target chan num_winning_rounds {users_list {#}}} {
	set ::duel::sessions([set chan_hash [md5 $chan]]) ""
	if { ![::tcl::info::exists ::duel::attack_indexes($chan_hash)] } {
		::duel::build_random_attacks_list $chan_hash
		::duel::build_random_failed_attacks_list $chan_hash
		::duel::build_random_defenses_list $chan_hash
		::duel::build_random_reactions_list $chan_hash
	}
	if { $num_winning_rounds eq "" } { set num_winning_rounds $::duel::default_num_winning_rounds }
	set max_rounds [expr { $num_winning_rounds * $::duel::max_rounds_factor }]
	if { $users_list eq "#" } {
		set users_list [chanlist $chan]
	}
	set avoidance_pending 0
	set reaction_pending 0
	set nick_score 0
	set target_score 0
	set round_counter 1
	set attack_counter 1
	set reached_max_rounds 0
	# On prcalcule le droulement le plus court pour avoir une victoire, ce
	# qui nous permettra de nous assurer qu'au moins une dfense s'y trouve
	# quand l'option must_defend_once est active.
	set testscore1 0
	set testscore2 0
	set counter 1
	while { ($testscore1 < $num_winning_rounds) && ($testscore2 < $num_winning_rounds) } {
		# $attack_type peut valoir : 0 = $nick attaque, 1 = $target attaque, 2 = $nick rate son attaque, 3 = $target rate son attaque
		# remarque : on empche une attaque rate de se produire au 1er round
		# La valeur qui accompagne $attack_type peut valoir 0 = pas de dfense ni de raction  l'attaque, 1 = dfense, 2 = raction neutre
		if { ($counter > 1) && ([::duel::randgen 100 1] <= $::duel::fail_rate) } {
			set attack_type [expr { [::duel::randgen 2 2] }]
		} else {
			set attack_type [::duel::randgen 2 0]
		}
		lappend duel_sequence [list $attack_type "0"]
		if { !$attack_type } {
			incr testscore1 1
		} elseif { $attack_type == 1 } {
			incr testscore2 1
		}
		incr counter 1
	}
	# Si l'option must_defend_once est active, on place au moins une dfense
	if { $::duel::must_defend_once } {
		set successful_attacks_indexes [lsearch -all -index 0 -regexp $duel_sequence {[01]}]
		set random_index [lindex $successful_attacks_indexes [::duel::randgen [llength $successful_attacks_indexes] 0]]
		set duel_sequence [lreplace $duel_sequence $random_index $random_index [list [lindex $duel_sequence $random_index 0] 1]]
	}
	# On prcalcule la suite de la trame du droulement du duel
	for { set counter 1 } { $counter <= 100 } { incr counter 1 } {
		if { [::duel::randgen 100 1] <= $::duel::fail_rate } {
			set attack_type [expr { [::duel::randgen 2 2] }]
		} else {
			set attack_type [::duel::randgen 2 0]
		}
		lappend duel_sequence [list $attack_type "0"]
	}
	# On place alatoirement les dfenses et les ractions neutres
	for { set counter 0 } { $counter < [llength $duel_sequence] } { incr counter 1 } {
		set attack_type [lindex $duel_sequence $counter 0]
		if { !($attack_type in {2 3}) && !([lindex $duel_sequence $counter 1]) } {
			if { [::duel::randgen 100 1] <= $::duel::avoidance_rate } {
				set duel_sequence [lreplace $duel_sequence $counter $counter [list [lindex $duel_sequence $counter 0] 1]]
			} elseif { [::duel::randgen 100 1] <= $::duel::neutral_reaction_rate } {
				set duel_sequence [lreplace $duel_sequence $counter $counter [list [lindex $duel_sequence $counter 0] 2]]
			} else {
				continue
			}
		} else {
			continue
		}
	}
	### Le duel commence
	while { ($nick_score < $num_winning_rounds) && ($target_score < $num_winning_rounds) } {
		### Une manoeuvre de dfense est en attente
		if { $avoidance_pending } {
			set avoidance_pending 0
			# On choisit une esquive au hasard
			lassign [::duel::get_next_action_data 2 $chan_hash $attack_index] defense_type defense_text
			# Recalcul des scores
			switch -- $defense_type {
				E {
					if { $::duel::display_symbols } { set defense_text "$::duel::E_symbol $defense_text" }
				}
				EC {
					if { $direction } {
						incr nick_score 1
					} else {
						incr target_score 1
					}
					if { $::duel::display_symbols } { set defense_text "$::duel::EC_symbol $defense_text" }
				}
				C {
					incr nick_score 1
					incr target_score 1
					if { $::duel::display_symbols } { set defense_text "$::duel::C_symbol $defense_text" }
				}
			}
			::duel::output_message $chan special PRIVMSG [::duel::substitute_variables $nick $target $aggressor $victim $chan $defense_text]
			if { [::tcl::info::exists ::duel::randnicks($chan_hash)] } {
				unset ::duel::randnicks($chan_hash)
			}
			unset ::duel::nicklist($chan_hash)
		### Une raction est en attente
		} elseif { $reaction_pending } {
			set reaction_pending 0
			# On choisit une raction au hasard
			if { $::duel::display_symbols } {
				set reaction_text "$::duel::R_symbol [lindex $reactions [::duel::get_next_action_data 3 $chan_hash $attack_index]]"
			} else {
				set reaction_text [lindex $reactions [::duel::get_next_action_data 3 $chan_hash $attack_index]]
			}
			::duel::output_message $chan special PRIVMSG [::duel::substitute_variables $nick $target $aggressor $victim $chan $reaction_text]
			if { [::tcl::info::exists ::duel::randnicks($chan_hash)] } {
				unset ::duel::randnicks($chan_hash)
			}
			unset ::duel::nicklist($chan_hash)
		### Attaque
		} else {
			# Le nombre maximum de rounds autoris est dpass, on affiche le score final et on arrte
			if { ($max_rounds != 0) && ($round_counter > $max_rounds) } {
				set reached_max_rounds 1
				break
			# Le nombre maximum de rounds autoris n'est pas encore dpass, on procde  l'attaque
			} else {
				set ::duel::nicklist($chan_hash) $users_list
				lassign [lindex $duel_sequence [expr {$attack_counter - 1}]] attack_type some_action_pending
				# On note si l'attaque en cours doit enchaner sur une dfense, sur une raction ou sur rien du tout
				switch -- $some_action_pending {
					0 {
						set avoidance_pending 0
						set reaction_pending 0
					}
					1 {
						set avoidance_pending 1
						set reaction_pending 0
					}
					2 {
						set avoidance_pending 0
						set reaction_pending 1
					}
				}
				# Distribution des rles et des points
				# attaque sans dfense
				if { !$avoidance_pending } {
					switch -- $attack_type {
						0 {
							if { $::duel::HL_prevention } {
								set aggressor "[string index $nick 0]\342\201\243[string range $nick 1 end]"
								set victim "[string index $target 0]\342\201\243[string range $target 1 end]"
							} else {
								set aggressor $nick
								set victim $target
							}
							incr nick_score 1
						}
						1 {
							if { $::duel::HL_prevention } {
								set aggressor "[string index $target 0]\342\201\243[string range $target 1 end]"
								set victim "[string index $nick 0]\342\201\243[string range $nick 1 end]"
							} else {
								set aggressor $target
								set victim $nick
							}
							incr target_score 1
						}
						2 {
							if { $::duel::HL_prevention } {
								set aggressor "[string index $nick 0]\342\201\243[string range $nick 1 end]"
								set victim "[string index $target 0]\342\201\243[string range $target 1 end]"
							} else {
								set aggressor $nick
								set victim $target
							}
						}
						3 {
							if { $::duel::HL_prevention } {
								set aggressor "[string index $target 0]\342\201\243[string range $target 1 end]"
								set victim "[string index $nick 0]\342\201\243[string range $nick 1 end]"
							} else {
								set aggressor $target
								set victim $nick
							}
						}
					}
				# Attaque avec dfense
				} else {
					switch -- $attack_type {
						0 - 2 {
							set direction 0
							if { $::duel::HL_prevention } {
								set aggressor "[string index $nick 0]\342\201\243[string range $nick 1 end]"
								set victim "[string index $target 0]\342\201\243[string range $target 1 end]"
							} else {
								set aggressor $nick
								set victim $target
							}
						}
						1 - 3 {
							set direction 1
							if { $::duel::HL_prevention } {
								set aggressor "[string index $target 0]\342\201\243[string range $target 1 end]"
								set victim "[string index $nick 0]\342\201\243[string range $nick 1 end]"
							} else {
								set aggressor $target
								set victim $nick
							}
						}
					}
				}
				# Rcupration du texte de l'attaque
				switch -- $attack_type {
					0 - 1 {
						# On choisit une attaque au hasard
						set attack_data [lindex $::duel::attacks [set attack_index [::duel::get_next_action_data 0 $chan_hash -]]]
						lassign $attack_data attack_text defenses reactions
						if { $::duel::display_symbols } { set attack_text "$::duel::A_symbol $attack_text" }								
					}
					2 - 3 {
						# On choisit une attaque rate au hasard
						set attack_text [::duel::get_next_action_data 1 $chan_hash -]
						if { $::duel::display_symbols } { set attack_text "$::duel::F_symbol $attack_text" }
					}
				}
				::duel::output_message $chan special PRIVMSG [::duel::substitute_variables $nick $target $aggressor $victim $chan $attack_text]
				incr attack_counter 1
			}
		}
		# Si l'option there_can_be_only_one est active, on empche l'galit  l'issue du duel
		if { (($nick_score >= $num_winning_rounds)
			|| ($target_score >= $num_winning_rounds))
			&& ($::duel::there_can_be_only_one
			&& ($nick_score - $target_score == 0))
		} then {
			incr num_winning_rounds 1
		}
		incr round_counter 1
		# Si on a des %randnick<index>% en mmoire, on les oublie  la fin du round.
	}
	### Affichage des rsultats
	# La limite max de rounds a t atteinte et le duel s'est termin prmaturment
	if { $reached_max_rounds } {
		if { $nick_score > $target_score } {
			# Message : "Les duellistes sont  bout de forces et dcident d'en rester l... pour l'instant. %s gagne : %s %s - %s %s"
			set text [::msgcat::mc m10 $nick $nick $nick_score $target_score $target]
		} elseif { $target_score > $nick_score } {
			# Message : "Les duellistes sont  bout de forces et dcident d'en rester l... pour l'instant. %s gagne : %s %s - %s %s"
			set text [::msgcat::mc m10 $target $target $target_score $nick_score $nick]
		} else {
			# Message : "Les duellistes sont  bout de forces et dcident d'en rester l... pour l'instant. Personne n'a gagn : %s %s - %s %s"
			set text [::msgcat::mc m11 $nick $nick_score $target_score $target]
		}
	# Le duel est arriv  son terme
	} else {
		if { $nick_score > $target_score } {
			# Message : "%s gagne. Score final : %s %s - %s %s"
			set text [::msgcat::mc m12 $nick $nick $nick_score $target_score $target]
		} elseif { $nick_score < $target_score } {
			# Message : "%s gagne. Score final : %s %s - %s %s"
			set text [::msgcat::mc m12 $target $target $target_score $nick_score $nick]
		} else {
			# Message : "%s et %s tombent en coeur, personne ne gagne. Score final : %s %s - %s %s"
			set text [::msgcat::mc m13 $nick $target $target $target_score $nick_score $nick]
		}
	}
	::duel::output_message $chan special PRIVMSG $text
	lappend ::duel::special_queue [list "-END-" $chan]
	if { !$::duel::special_queue_running } {
		::duel::process_special_queue
	}
}

 ###############################################################################
### Susbstitution des %randnick% %aggressor% et %victim% et neutralisation des
### antislashes, sauf codes de style
 ###############################################################################
proc ::duel::substitute_variables {nick target aggressor victim chan text} {
	# Neutralisation des antislashes (sauf codes de style \002 \003 \022 \037 \026 \017 et guillemets)
	set text [join [regsub -all {(?!\\002|\\003|\\022|\\037|\\026|\\017|\\")(\\)} $text {\\\\}]]
	# Remplacement des %randnick% par un nick choisi alatoirement parmi les users
	# prsents sur le chan. 
	# On s'assure qu'un mme nick ne sera pas utilis plus d'une fois. Si on a
	# plus de %randnick%  remplacer qu'il n'y a d'users sur le chan, on remplace
	# ceux en trop par "quelqu'un"
	set num_randnick [regexp -all {%randnick%} $text]
	set num_randnick2 [llength [set randnick_list [lsort -unique [regexp -inline -all {%randnick\d+%} $text]]]]
	if {
		($num_randnick != 0)
		|| ($num_randnick2 != 0)
	} then {
		set chan_hash [md5 $chan]
		# On rcupre la liste des users prsents sur le chan, sauf le nick de l'Eggdrop et les nicks des duellistes
		set ::duel::nicklist($chan_hash) [lsearch -all -exact -inline -not $::duel::nicklist($chan_hash) $::nick]
		set ::duel::nicklist($chan_hash) [lsearch -all -exact -inline -not $::duel::nicklist($chan_hash) $nick]
		set ::duel::nicklist($chan_hash) [lsearch -all -exact -inline -not $::duel::nicklist($chan_hash) $target]
		# Exclusion des handles/nicks spcifis dans $::duel::exempted_users
		foreach user $::duel::exempted_users {
			if { [set handle2nick [hand2nick $user $chan]] ne "" } { set user $handle2nick }
			set ::duel::nicklist($chan_hash) [::duel::randomize_list [lsearch -all -exact -inline -not $::duel::nicklist($chan_hash) $user]]
		}
		# Construction de la liste de remplacement pour les %randnick<index>%
		foreach randnick $randnick_list {
			set index [regexp -inline {\d+} $randnick]
			if {
				([::tcl::info::exists ::duel::randnicks($chan_hash)])
				&& ([::tcl::dict::exists $::duel::randnicks($chan_hash) $index])
			} then {
				lappend replacement_list [::tcl::dict::get $::duel::randnicks($chan_hash) $index]
			} else {
				if { [set num_remaining_users [llength $::duel::nicklist($chan_hash)]] != 0 } {
					set chosen_nick [lindex $::duel::nicklist($chan_hash) [set calculated_index [expr $index % $num_remaining_users]]]
					set ::duel::nicklist($chan_hash) [lreplace $::duel::nicklist($chan_hash) $calculated_index $calculated_index]
				} else {
					# Message : "quelqu'un"
					set chosen_nick [::msgcat::mc m14]
				}
				::tcl::dict::set ::duel::randnicks($chan_hash) $index $chosen_nick
				lappend replacement_list $chosen_nick
			}
		}
		# Remplacement des %randnick<index>%
		for { set counter 1 } { $counter <= $num_randnick2 } { incr counter 1 } {
			regsub [lindex $randnick_list $counter-1] $text [lindex $replacement_list $counter-1] text
		}
		# Construction de la liste de remplacement pour les %randnick%
		set replacement_list {}
		for { set counter 1 } { $counter <= $num_randnick } { incr counter 1 } {
			if { [set num_remaining_users [llength $::duel::nicklist($chan_hash)]] != 0 } {
				set index [::duel::randgen $num_remaining_users 0]
				lappend replacement_list [lindex $::duel::nicklist($chan_hash) $index]
				set ::duel::nicklist($chan_hash) [lreplace $::duel::nicklist($chan_hash) $index $index]
			} else {
				# Message : "quelqu'un"
				lappend replacement_list [::msgcat::mc m14]
			}
		}
		# Remplacement des %randnick%
		for { set counter 1 } { $counter <= $num_randnick } { incr counter 1 } {
			regsub {%randnick%} $text [lindex $replacement_list $counter-1] text
		}
	}
	# Remplacement des variables %aggressor% et %victim%
	return [::tcl::string::map "%aggressor% $aggressor %victim% $victim" $text]
}

 ###############################################################################
### Construction de listes d'index en ordre alatoire. Ce systme permet de
### s'assurer qu'une mme action (tous types confondus) ne sortira pas 2 fois
### avant que toutes les autres soient sorties.
 ###############################################################################
proc ::duel::build_random_attacks_list {chan_hash} {
	set ::duel::attack_indexes($chan_hash) [::duel::randomize_list [lsearch -all $::duel::attacks *]]
	set ::duel::current_attack_index($chan_hash) 0
	return
}
proc ::duel::build_random_failed_attacks_list {chan_hash} {
	set ::duel::failed_attack_indexes($chan_hash) [::duel::randomize_list [lsearch -all $::duel::failed_attacks *]]
	set ::duel::current_failed_attack_index($chan_hash) 0
	return
}
proc ::duel::build_random_defenses_list {chan_hash} {
	set attack_index 0
	foreach attack_data $::duel::attacks {
		dict set ::duel::defense_indexes($chan_hash) $attack_index [::duel::randomize_list [lsearch -all [lindex $attack_data 1] *]]
		dict set ::duel::current_defense_index($chan_hash) $attack_index 0
		incr attack_index 1
	}
	return
}
proc ::duel::build_individual_random_defenses_list {chan_hash attack_index} {
	dict set ::duel::defense_indexes($chan_hash) $attack_index [::duel::randomize_list [lsearch -all [lindex $::duel::attacks $attack_index 1] *]]
	dict set ::duel::current_defense_index($chan_hash) $attack_index 0
	return
}
proc ::duel::build_random_reactions_list {chan_hash} {
	set attack_index 0
	foreach attack_data $::duel::attacks {
		dict set ::duel::reaction_indexes($chan_hash) $attack_index [::duel::randomize_list [lsearch -all [lindex $attack_data 2] *]]
		dict set ::duel::current_reaction_index($chan_hash) $attack_index 0
		incr attack_index 1
	}
	return
}
proc ::duel::build_individual_random_reactions_list {chan_hash attack_index} {
	dict set ::duel::reaction_indexes($chan_hash) $attack_index [::duel::randomize_list [lsearch -all [lindex $::duel::attacks $attack_index 2] *]]
	dict set ::duel::current_reaction_index($chan_hash) $attack_index 0
	return
}

 ###############################################################################
### Retourne la prochaine action ou son index dans les listes d'index alatoires
### Type peut valoir 0 (attaque), 1 (attaque rate), 2 (dfense) ou 3 (raction)
### Attack_index reprsente l'index de l'attaque et n'est utilis que si type
### vaut 2 ou 3.
### Le type 0 retourne l'index de l'attaque
### Le type 1 retourne le texte de l'attaque rate
### Le type 2 retourne le couple {type de dfense} {dfense}
### Le type 3 retourne l'index de la raction
 ###############################################################################
proc ::duel::get_next_action_data {type chan_hash attack_index} {
	switch -- $type {
		0 {
			set data [lindex $::duel::attack_indexes($chan_hash) $::duel::current_attack_index($chan_hash)]
			if { $::duel::current_attack_index($chan_hash) < [llength $::duel::attack_indexes($chan_hash)] - 1 } {
				incr ::duel::current_attack_index($chan_hash) 1
			} else {
				::duel::build_random_attacks_list $chan_hash
				set ::duel::current_attack_index($chan_hash) 0
			}
		}
		1 {
			set data [lindex $::duel::failed_attacks [lindex $::duel::failed_attack_indexes($chan_hash) $::duel::current_failed_attack_index($chan_hash)]]
			if { $::duel::current_failed_attack_index($chan_hash) < [llength $::duel::failed_attack_indexes($chan_hash)] - 1 } {
				incr ::duel::current_failed_attack_index($chan_hash) 1
			} else {
				::duel::build_random_failed_attacks_list $chan_hash
				set ::duel::current_failed_attack_index($chan_hash) 0
			}
		}
		2 {
			set data [lindex $::duel::attacks $attack_index 1 [lindex [dict get $::duel::defense_indexes($chan_hash) $attack_index] [dict get $::duel::current_defense_index($chan_hash) $attack_index]]]
			if { [dict get $::duel::current_defense_index($chan_hash) $attack_index] < [llength [dict get $::duel::defense_indexes($chan_hash) $attack_index]] - 1 } {
				dict incr ::duel::current_defense_index($chan_hash) $attack_index 1
			} else {
				::duel::build_individual_random_defenses_list $chan_hash $attack_index
				dict set ::duel::current_defense_index($chan_hash) $attack_index 0
			}
		}
		3 {
			set data [lindex [dict get $::duel::reaction_indexes($chan_hash) $attack_index] [dict get $::duel::current_reaction_index($chan_hash) $attack_index]]
			if { [dict get $::duel::current_reaction_index($chan_hash) $attack_index] < [llength [dict get $::duel::reaction_indexes($chan_hash) $attack_index]] - 1 } {
				dict incr ::duel::current_reaction_index($chan_hash) $attack_index 1
			} else {
				::duel::build_individual_random_reactions_list $chan_hash $attack_index
				dict set ::duel::current_reaction_index($chan_hash) $attack_index 0
			}
		}
	}
	return $data
}

 ###############################################################################
### Affichage d'un message.
### target peut tre un nick ou un chan et sera ignor si output_mode
###		vaut PARTYLINE
### queue peut valoir quick, help ou special et sera ignor si output_mode
### 	vaut PARTYLINE
### output_mode peut valoir PRIVMSG, NOTICE ou PARTYLINE
 ###############################################################################
proc ::duel::output_message {target queue output_mode data} {
	# Filtrage des styles si ncessaire
	set must_break 0
	if { ([::tcl::string::match "#*" $target]) && ([::tcl::string::match *c* [lindex [split [getchanmode $target]] 0]]) } {
		set monochrome 1
		regsub -all "\017" [stripcodes abcgru $data] "" data
	} else {
		set monochrome 0
	}
	if { $output_mode eq "PARTYLINE" } {
		foreach line [::duel::split_line $data $::duel::max_line_length] {
			putloglev o * $line
		}
	} else {
		foreach line [::duel::split_line $data $::duel::max_line_length] {
			if { $queue eq "special" } {
				lappend ::duel::special_queue "$output_mode $target :$line"
			} else {
				put[set queue] "$output_mode $target :$line"
			}
		}
	}
	return
}

 ###############################################################################
### Affichage des erreurs d'utilisation
 ###############################################################################
proc ::duel::display_error_msg {chan error_msg} {
	::duel::output_message $chan help PRIVMSG $error_msg
	::duel::antiflood_close_instance [md5 $chan]
	return
}

 ###############################################################################
### Dcoupage d'une ligne trop longue en plusieurs lignes en essayant de couper
### sur les espaces autant que possible.
### Les \n provoquent un retour  la ligne.
 ###############################################################################
proc ::duel::split_line {data {limit 1}} {
	incr limit -1
	set data [::tcl::string::trim $data]
	set data_length [::tcl::string::length $data]
	if { $data_length <= $limit } {
		return [split $data "\n"]
	} else {
		set cursor 0
		# Note : si l'espace le plus proche est situ  plus de 50% de la fin du
		# fragment, on n'hsite pas  couper au milieu d'un mot.
		set middle_pos [expr round($limit / 2.0)]
		while { $cursor < $data_length } {

		if { ([set cut_index [::tcl::string::first "\n" $data $cursor]] != -1)
			&& ($cut_index <= $cursor + $limit)
		} then {
			# on ne fait rien de plus, on vient de dfinir $cut_index
		} elseif { ([set cut_index [::tcl::string::last " " $data [expr {$cursor + $limit + 1}]]] == -1)
				|| ($cut_index <= $cursor)
				|| ($data_length - $cursor < $limit)
				|| ($cut_index - $cursor < $middle_pos)
			} then {
				set cut_index [expr {$cursor + $limit}]
			}
			lappend output [::tcl::string::trimright [::tcl::string::range $data $cursor $cut_index]]
			set cursor [expr {$cut_index + 1}]
		}
		return $output
	}
}

 ###############################################################################
### Traitement de la file d'attente spciale pour l'affichage des messages.
### Cette file d'attente spare permet de ne pas engorger la file d'attente
### puthelp en y envoyant beaucoup de lignes d'un coup.
 ###############################################################################
proc ::duel::process_special_queue {} {
	set ::duel::special_queue_running 1
	if { [lindex [set queue_line [lindex $::duel::special_queue 0]] 0] ne "-END-" } {
		puthelp $queue_line
	} else {
		unset ::duel::sessions([md5 [lindex $queue_line 1]])
	}
	set ::duel::special_queue [lreplace $::duel::special_queue 0 0]
	if { [llength $::duel::special_queue] > 0 } {
		utimer $::duel::delay ::duel::process_special_queue
	} else {
		set ::duel::special_queue_running 0
	}
	return
}

 ###############################################################################
### !duels on/off : commande publique pour l'activation/dsactivation des duels
### sur le chan en cours.
 ###############################################################################
proc ::duel::switch_command {nick host hand chan arg} {
	if { (![::tcl::string::equal -nocase $arg "on"])
		&& (![::tcl::string::equal -nocase $arg "off"])
	} then {
		# Message : "\037Syntaxe\037 : \002%s\002 \00314<\003on\00314/\003off\00314>\003 \00307|\003 Active/dsactive les duels sur %s."
		::duel::output_message $chan help PRIVMSG [::msgcat::mc m15 $::duel::switch_cmd $chan]
		return
	}
	if { [::tcl::string::equal -nocase $arg "on"] } {
		if { ![channel get $chan duel] } {
			channel set $chan +duel
			# Message : "Les duels sont maintenant activs sur %s. Utilisez la commande \002%s\002 pour lancer un dfi  quelqu'un."
			::duel::output_message $chan help PRIVMSG [::msgcat::mc m16 $chan $::duel::public_cmd]
		} else {
			# Message : "Les duels sont dj activs sur %s. Utilisez la commande \002%s\002 pour lancer un dfi  quelqu'un."
			::duel::output_message $chan help PRIVMSG [::msgcat::mc m17 $chan $::duel::public_cmd]
		}
	} elseif { [::tcl::string::equal -nocase $arg "off"] } {
		if {[channel get $chan duel] == 1} {
			channel set $chan -duel
			# Message : "Les duels sont maintenant dsactivs sur %s."
			::duel::output_message $chan help PRIVMSG [::msgcat::mc m18 $chan]
		} else {
			# Message : "Les duels sont dj dsactivs sur %s."
			::duel::output_message $chan help PRIVMSG [::msgcat::mc m19 $chan]
		}
	}
}

 ###############################################################################
### Contrle du flood
### Note :
###   antiflood_msg = 0 : l'antiflood n'a pas encore t dclench
###   antiflood_msg = 1 : message "antiflood toujours actif" dj affich
###   antiflood_msg = 2 : message "antiflood dclench" dj affich
 ###############################################################################
proc ::duel::antiflood {chan nick} {
	set chan_hash [md5 $chan]
	# l'antiflood est dans un statut neutre, on l'initialise
	if { ![::tcl::info::exists ::duel::instance($chan_hash)] } {
		set ::duel::instance($chan_hash) 0
		set ::duel::antiflood_msg($chan_hash) 0
	}
	lassign [split $::duel::flood_threshold ":"] max_instances instance_length
	if { $::duel::instance($chan_hash) >= $max_instances } {
		if { !$::duel::antiflood_msg($chan_hash) } {
			set ::duel::antiflood_msg($chan_hash) 2
			# Message : "\00304:::\003 \00314Contrle de flood activ pour la commande \002%s\002 : pas plus de %s requte(s) toutes les %s secondes.\003"
			::duel::output_message $chan help PRIVMSG [::msgcat::mc m20 $::duel::public_cmd $max_instances $instance_length]
			if { [set msgresettimer [::duel::utimerexists "::duel::antiflood_msg_reset $chan_hash"]] ne ""} { killutimer $msgresettimer }
			utimer $::duel::antiflood_msg_interval [list ::duel::antiflood_msg_reset $chan_hash]
		} elseif { $::duel::antiflood_msg($chan_hash) == 1 } {
			set ::duel::antiflood_msg($chan_hash) 2
			# Message : "\00304:::\003 \00314Le contrle de flood est toujours actif, merci de patienter.\003"
			::duel::output_message $chan help PRIVMSG [::msgcat::mc m21]
			if { [set msgresettimer [::duel::utimerexists "::duel::antiflood_msg_reset $chan_hash"]] ne ""} { killutimer $msgresettimer }
			utimer $::duel::antiflood_msg_interval [list ::duel::antiflood_msg_reset $chan_hash]
		}
		return "1"
	} else {
		incr ::duel::instance($chan_hash) 1
		utimer $instance_length [list ::duel::antiflood_close_instance $chan_hash]
		return "0"
	}
}
proc ::duel::antiflood_close_instance {chan_hash} {
	incr ::duel::instance($chan_hash) -1
	# si le nombre d'instances retombe  0, on efface les variables instance et
	# antiflood_msg afin de ne pas encombrer la mmoire inutilement
	if { $::duel::instance($chan_hash) == 0 } {
		unset ::duel::instance($chan_hash)
		unset ::duel::antiflood_msg($chan_hash)
	# le nombre d'instances est retomb en dessous du seuil critique, on
	# rinitialise antiflood_msg
	} else {
		set ::duel::antiflood_msg($chan_hash) 0
		if { [set msgresettimer [::duel::utimerexists "::duel::antiflood_msg_reset $chan_hash"]] ne ""} { killutimer $msgresettimer }
	}
	return
}
proc ::duel::antiflood_msg_reset {chan_hash} {
	set ::duel::antiflood_msg($chan_hash) 1
	return
}

 ###############################################################################
### Test de l'existence d'un utimer, renvoi de son ID
 ###############################################################################
proc ::duel::utimerexists {command} {
	foreach utimer_ [utimers] {
		if { ![::tcl::string::compare $command [lindex $utimer_ 1]] } {
			return [lindex $utimer_ 2]
		}
	}
}

 ###############################################################################
### Mlange alatoire des lments d'une liste
 ###############################################################################
proc ::duel::randomize_list {data} {
	if { ![set list_length [llength $data]] } {
		return {}
	} else {
		for { set counter 1 } { $counter <= $list_length } { incr counter } {
			set index [::duel::randgen [expr {$list_length - $counter + 1}] 0]
			lappend randomized_list [lindex $data $index]
			set data [lreplace $data $index $index]
		}
		return $randomized_list
	}
}

 ###############################################################################
### Gnrateur de nombres pseudo-alatoires de George Marsaglia
### rfrence : http://wiki.tcl.tk/19710
### Remarque : on utilise un gnrateur alternatif car celui de Tcl est foireux
 ###############################################################################
proc ::duel::randgen {factor offset} {
	set xn [expr { ($::duel::randgen_fac * ($::duel::randgen_x3 + $::duel::randgen_x2 + $::duel::randgen_x1))%$::duel::randgen_mod }]
	set ::duel::randgen_x1 $::duel::randgen_x2
	set ::duel::randgen_x2 $::duel::randgen_x3
	set ::duel::randgen_x3 $xn
	return [expr { int(($xn / double($::duel::randgen_mod) * $factor) + $offset) }]
}

 ##############################################################################
### Commande !duel_stats : affiche le nombre d'attaques, de dfenses et
### d'attaques rates dans la base de donnes
 ##############################################################################
proc ::duel::stats {nick host hand chan arg} {
	set num_failed_attacks [llength $::duel::failed_attacks]
	set num_attacks [llength $::duel::attacks]
	foreach attack $::duel::attacks {
		incr num_E [llength [lsearch -all -index 0 [lindex $attack 1] "E"]]
		incr num_C [llength [lsearch -all -index 0 [lindex $attack 1] "C"]]
		incr num_EC [llength [lsearch -all -index 0 [lindex $attack 1] "EC"]]
		if { [regsub -all {[\}\{\s]} [set reactions [lindex $attack 2]] ""] ne "" } {
			incr num_R [llength $reactions]
		}
	}
	# Message : "\00314La base de donnes contient \003\002%s\002\00314 attaques, \003\002%s\002\00314 esquives, \003\002%s\002\00314 contre-attaques, \003\002%s\002\00314 esquives avec contre-attaque, \003\002%s\002\00314 attaques rates et \003\002%s\002\00314 ractions neutres."
	::duel::output_message $chan help PRIVMSG [::msgcat::mc m22 $num_attacks $num_E $num_C $num_EC $num_failed_attacks $num_R]
	return
}

 ##############################################################################
### Vrification sommaire de la validit de la base de donnes
 ##############################################################################
proc ::duel::db_sanity_check {} {
	set errors_found 0
	for { set counter 0 } { $counter < [llength $::duel::attacks] } { incr counter 1 } {
		if { [set typos_list [regexp -all -inline {(?:%victime?(?!%|$)|%victime%|%ag+ressor(?!%|$)|%agressor%|%randnick(?!(\d+)?%|$))} [lindex $::duel::attacks $counter]]] ne "" } {
			# Message : "\00304\[%s - avertissement\]\003 : une ou plusieurs variables sont mal orthographies dans l'attaque n%s (index %s) : %s"
			::duel::output_message - - PARTYLINE [::msgcat::mc m23 $::duel::scriptname [expr {$counter + 1}] $counter $typos_list]
			::duel::output_message - - PARTYLINE "--> \00314[lindex $::duel::attacks $counter]"
			set errors_found 1
		}
		if { [set defenses [lindex $::duel::attacks $counter 1]] eq "" } {
			# Message : "\00304\[%s - erreur\]\003 : dfenses manquantes pour l'attaque n%s (index %s)"
			::duel::output_message - - PARTYLINE [::msgcat::mc m24 $::duel::scriptname [expr {$counter + 1}] $counter]
			::duel::output_message - - PARTYLINE "--> \00314[lindex $::duel::attacks $counter]"
			set errors_found 1
		} else {
			foreach defense $defenses {
				if { [lindex $defense 1] eq "" } {
					# Message : "\00304\[%s - erreur\]\003 : erreur de structure dans les dfenses de l'attaque n%s (index %s) : sous-liste manquante"
					::duel::output_message - - PARTYLINE [::msgcat::mc m25 $::duel::scriptname [expr {$counter + 1}] $counter]
					::duel::output_message - - PARTYLINE "--> \00314[lindex $::duel::attacks $counter]"
					set errors_found 1
				} elseif { !([set type [lindex $defense 0]] in {E EC C}) } {
					# Message : "\00304\[%s - erreur\]\003 : erreur de structure dans les dfenses de l'attaque n%s (index %s) : type %s inconnu"
					::duel::output_message - - PARTYLINE [::msgcat::mc m26 $::duel::scriptname [expr {$counter + 1}] $counter $type]
					::duel::output_message - - PARTYLINE "--> \00314[lindex $::duel::attacks $counter]"
					set errors_found 1
				}
			}
		}
		if { [llength [lindex $::duel::attacks $counter]] < 3 } {
			# Message : "\00304\[%s - erreur\]\003 : champ de ractions neutres manquant pour l'attaque n%s (index %s)"
			::duel::output_message - - PARTYLINE [::msgcat::mc m27 $::duel::scriptname [expr {$counter + 1}] $counter]
			::duel::output_message - - PARTYLINE "--> \00314[lindex $::duel::attacks $counter]"
			set errors_found 1
		} elseif { [llength [lindex $::duel::attacks $counter]] > 3 } {
			# Message : "\00304\[%s - erreur\]\003 : nombre de champs incorrect pour l'attaque n%s (index %s). Il doit y avoir 3 champs : attaque, dfenses, ractions neutres."
			::duel::output_message - - PARTYLINE [::msgcat::mc m28 $::duel::scriptname [expr {$counter + 1}] $counter]
			::duel::output_message - - PARTYLINE "--> \00314[lindex $::duel::attacks $counter]"
			set errors_found 1
		}
	}
	for { set counter 0 } { $counter < [llength $::duel::failed_attacks] } { incr counter 1 } {
		if { [set typos_list [regexp -all -inline {(?:%victime?(?!%|$)|%victime%|%ag+ressor(?!%|$)|%agressor%)} [lindex $::duel::failed_attacks $counter]]] ne "" } {
			# Message : "\00304\[%s - avertissement\]\003 : une ou plusieurs variables sont mal orthographies dans l'attaque rate n%s (index %s) : %s"
			::duel::output_message - - PARTYLINE [::msgcat::mc m29 $::duel::scriptname [expr {$counter + 1}] $counter $typos_list]
			::duel::output_message - - PARTYLINE "--> \00314[lindex $::duel::failed_attacks $counter]"
			set errors_found 1
		}
	}
	return $errors_found
}

 ###############################################################################
### Binds
 ###############################################################################
bind evnt - prerehash ::duel::uninstall
bind pubm $::duel::public_cmd_auth "% %$::duel::public_cmd *" ::duel::init_fight
bind pubm $::duel::public_cmd_auth "% %$::duel::public_cmd" ::duel::init_fight
bind pubm -|- "% %$::duel::acceptance_cmd" ::duel::duel_acceptance
bind pub $::duel::switch_cmd_auth $::duel::switch_cmd ::duel::switch_command
bind pub n|n !duel_stats ::duel::stats

 ###############################################################################
### Post-initialisation
 ###############################################################################
::duel::db_sanity_check


#	Message : "%s v%s (2013-2015 Menz Agitat) a t charg."
namespace eval ::duel {
	putlog [::msgcat::mc m1 $::duel::scriptname $::duel::version]
}
